<?php 

namespace Advally\Advertising;

use XF\Entity\Option;
use XF\Repository\UserGroupRepository;
use XF\Option\AbstractOption;

class Configuration extends AbstractOption {

	/*
	 * Used by a Code EvenT Listener on the Option entity to update ads.txt on plugin enable
	 */
	static public function postSaveAdminCallback($entity) 
	{
		// Listen for changes to the global Enable flag for our plugin
		if ( $entity->get('option_id') == 'advally_enable') {

			// Watch for an update to the Enable flag
			if ($entity->isUpdate() && $entity->isChanged('option_value')) {

				// Update ads.txt when the plugin iss Enabled
				if ($entity->getOptionValue()) {
					Adstxt::updateNow();
				}
			}
		}
/*
		// Listen for changes to the additional ads.txt lines 
		if ( $entity->get('option_id') == 'advally_adstxt_addlines') {

			// Trigger if this is an update AND the lines were changed
			if ($entity->isUpdate() && $entity->isChanged('option_value')) {
				Adstxt::update( $entity->getOptionValue() );
			}
		}
*/

	}


	/*
	static public function bottomAdhesionAudienceOption(Option $option, array $htmlParams)
	{
		return self::audienceOption($option, $htmlParams);
	}
	
	static public function topAdhesionAudienceOption(Option $option, array $htmlParams)
	{
		return self::audienceOption($option, $htmlParams);
	}

	static public function interstitialAudienceOption(Option $option, array $htmlParams)
	{
		return self::audienceOption($option, $htmlParams);
	}
*/

	/*
	static public function groupOption(Option $option, array $htmlParams)
	{
		$userGroupRepo = \XF::repository(UserGroupRepository::class);

		$userGroups = $userGroupRepo->getUserGroupOptionsData(false, 'option');

		return static::getTemplate('admin:advally_option_template_groupSelect', $option, $htmlParams, [
			'groups' => $userGroups,
		]);
	}
	 */
/*
	static public function userTypeOption(Option $option, array $htmlParams)
	{
		$userGroupRepo = \XF::repository(UserGroupRepository::class);

		$userGroups = $userGroupRepo->getUserGroupOptionsData(false, 'option');

		return static::getTemplate('admin:advally_option_template_userTypeSelect', $option, $htmlParams, [
			'excludeGroups' => $userGroups,
		]);
	}
 */
	/*
	static public function bottomAdhesionDeviceOption(Option $option, array $htmlParams)
	{
		return self::deviceOption($option, $htmlParams);
	}
	
	static public function topAdhesionDeviceOption(Option $option, array $htmlParams)
	{
		return self::deviceOption($option, $htmlParams);
	}

	static public function interstitialDeviceOption(Option $option, array $htmlParams)
	{
		return self::deviceOption($option, $htmlParams);
	}
	 *//*
	static public function deviceTypeOption(Option $option, array $htmlParams)
	{
		return static::getTemplate('admin:advally_option_template_deviceTypeSelect', $option, $htmlParams, [
		]);
	}
	  */
	
	static public function verifyAlias(string &$value, Option $option) : bool 
	{
		
		// empty values okay
		if (empty($value))
			return true;

		// Lookuop the site wrapper
		$url = sprintf("https://cdn.adligature.com/%s/prod/rules.js", $value);

		$curl = curl_init();
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	    curl_setopt($curl, CURLOPT_URL, $url);
		$contents = curl_exec($curl);
	    curl_close($curl);

		if (curl_errno($curl)) {
			return false;
		} else {
			return (curl_getinfo($curl, CURLINFO_HTTP_CODE) == 200);
		}
	
	/*
		if (preg_match('/^(?:[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9-])?\.)+[a-z]{0,61}$/i', $value)) {
			return true;
		} else {
			$option->error(
				\XF::phrase('advally_advertising_validation_alias_error'),
				$option->option_id
			);
			return false;
		}
*/
	}

}
