<?php

namespace Advally\Advertising;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1() 
	{
		$this->schemaManager()->createTable('xf_advally_advertising_settings', function(Create $table)
		{
			$table->addColumn('name', 'varchar', '50');
			$table->addColumn('value', 'text');
			$table->addPrimaryKey('name');
		});
	}


	public function uninstallStep1()
	{
		    $this->schemaManager()->dropTable('xf_advally_advertising_settings');
	}
}
